﻿module DUtil.CTextFileWriter;
import std.encoding, std.stream;
import DUtil.EEncoding;

class CTextFileWriter
{
	private Stream mStream;
	private EEncoding mEncoding;
	private EncodingScheme mEncodingScheme;

	public this(Stream aStream, EEncoding aEncoding)
	{
		mStream = aStream;
		mEncoding = aEncoding;
		final switch (mEncoding)
		{
			case EEncoding.Unknown:
				throw new Exception("Invalid encoding");
			case EEncoding.ANSI:
				mEncodingScheme = EncodingScheme.create("windows-1252");//new EncodingSchemeWindows1252();
				break;
			case EEncoding.UTF8:
				mEncodingScheme = new EncodingSchemeUtf8();
				break;
			case EEncoding.UTF16LE:
				mEncodingScheme = new EncodingSchemeUtf16Native();
				break;
			case EEncoding.UTF16BE:
				throw new Exception("Not supported yet :(");
		}
	}



	public void Write(dstring aText)
	{
		foreach (dchar c; aText)
			Write(c);
	}



	public void Write(dchar aChar)
	{
		ubyte[4] Data;
		int Length = mEncodingScheme.encode(aChar, Data);
		mStream.write(Data[0 .. Length]);
	}
}